Bug 246803 - rpm: please add arm support
rpm: please add arm support
Product: Fedora
Classification: Fedora
Component: rpm (Show other bugs)
arm9 Linux
low Severity low
: ---
: ---
Assigned To: Panu Matilainen
Fedora Extras Quality Assurance
Depends On:
Blocks: ARMTracker
  Show dependency treegraph
Reported: 2007-07-04 21:53 EDT by Lennert Buytenhek
Modified: 2007-11-30 17:12 EST (History)
0 users

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2007-07-23 07:38:56 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Attachments (Terms of Use)
Spec file diff for ARM. (981 bytes, patch)
2007-07-04 21:53 EDT, Lennert Buytenhek
no flags Details | Diff
ARM config.guess tweak. (607 bytes, patch)
2007-07-04 21:56 EDT, Lennert Buytenhek
no flags Details | Diff
Implement RPMCANONGNU. (1.49 KB, patch)
2007-07-21 15:36 EDT, Lennert Buytenhek
no flags Details | Diff
Remaining rpm ARM spec file fixes. (499 bytes, patch)
2007-08-04 12:45 EDT, Lennert Buytenhek
no flags Details | Diff

  None (edit)
Description Lennert Buytenhek 2007-07-04 21:53:20 EDT
These two patches enable building the rawhide rpm package on ARM
platforms.  The issues addressed are:

1. On ARM platforms, we need a slight tweak to config.guess to be able
   to detect ARM EABI platforms.  This patch was submitted to the
   upstream rpm project recently as part of a larger ARM patch, and
   while almost all of that patch was merged into, this
   particular hunk for some reason wasn't.

2. On ARM EABI platforms, we want %{_gnu} to expand to "-gnueabi" (since
   building for EABI is signaled to binutils/gcc/glibc/etc by configuring
   with a target triple that ends in -gnueabi.)  The attached patch does
   a blunt s/-gnu$/%{_gnu}/ over macros.in at prep time, which fixes it,
   but this might not be the cleanest method.  Ideas welcome.

These patches allow building the rawhide rpm package on the arm
platform.  Please considering applying them.

Thanks for your time.
Comment 1 Lennert Buytenhek 2007-07-04 21:53:20 EDT
Created attachment 158570 [details]
Spec file diff for ARM.
Comment 2 Lennert Buytenhek 2007-07-04 21:56:19 EDT
Created attachment 158571 [details]
ARM config.guess tweak.
Comment 3 Panu Matilainen 2007-07-09 05:21:04 EDT
Ah.. the reason why config.guess tweak didn't get applied is that it's not
version controlled but is inherited from system libtool at build. I can carry
the config.guess patch temporarily in rawhide but the proper fix is to get the
config.guess tweak to libtool itself.

The s/-gnu$/%{_gnu}/ hack doesn't look right to me as it basically creates a
cyclic %_gnu definition. A better fix might be to figure it out in configure.ac
and make macros.in have something like %_gnu @RPMCANONGNU@ ?
Comment 4 Lennert Buytenhek 2007-07-21 15:36:21 EDT
Created attachment 159729 [details]

Thanks for your comments!

This patch implements your RPMCANONGNU suggestion -- how does it look?
It seems to do the trick for me on ARM, and doesn't seem to break x86_64
at least.
Comment 5 Lennert Buytenhek 2007-07-21 16:02:04 EDT
I submitted the config.guess ARM EABI patch to upstream some time ago:


Could you carry it until it gets merged into upstream (at which point
it'll end up in libtool semi-automatically)?  I'll pester the upstream
maintainer about merging it a bit more.

Note that the redhat-rpm-config %configure macro copies config.guess
from /usr/lib/rpm/redhat into the build directory, and the copy of
config.guess in redhat-rpm-config was already updated to recognise ARM
EABI.  And so, packages that use %configure will get that version of
config.guess automatically.  However, the RH rpm spec file doesn't
use %configure, so it builds with its own version of config.guess.
Comment 6 Panu Matilainen 2007-07-23 07:38:56 EDT
Both issues should be fixed in next rawhide build (currently building), holler
if not...
Comment 7 Lennert Buytenhek 2007-08-04 12:45:22 EDT
Created attachment 160696 [details]
Remaining rpm ARM spec file fixes.

The attached spec file diff is still necessary.  With this applied,
things look good to me.  I'm doing a test build now to make sure.

Thanks again.

Note You need to log in before you can comment on or make changes to this bug.